XIncludeFile "3D.pbi"
XIncludeFile "Game.pbi"
;Revoir les normales du sol pour ajouter des ombres !!

Procedure MakeMesh(*Player.s_Player)
  Define. l Options, i
  Define.f Scale
  Protected *Sommet, *Face, *Ptr.s_Vertex
    
  Options = #PB_Mesh_Vertex | #PB_Mesh_Normal | #PB_Mesh_UVCoordinate  
  *Sommet=AllocateMemory(SizeOf(s_Vertex)*24)  
  *Face=AllocateMemory(6*12) 
  
  CopyMemory(?Sommets,*Sommet,SizeOf(s_Vertex)*24)
  CopyMemory(?Triangles,*Face,6*12)
  With *Player
  If \Taille=#Cube
    Scale=1
  Else
    Scale=2
  EndIf    
  Select \type
    Case #Vertical
      \s\x = 1 : \s\y = Scale : \s\z = 1
    Case #Nord, #Sud 
      \s\x = 1 : \s\y = 1 : \s\z = Scale
    Case #Ouest, #Est
      \s\x = Scale : \s\y = 1 : \s\z = 1
  EndSelect 
  
  Select \Sens
    Case #Nord
      \t\x = 0.5 : \t\y = 0.5 : \t\z = 0.5
    Case #Sud
      \t\x = 0.5 : \t\y = 0.5 : \t\z = -0.5
    Case #Ouest
      \t\x = 0.5 : \t\y = 0.5 : \t\z = 0
    Case #Est 
      \t\x = -0.5 : \t\y = 0.5 : \t\z = 0 
    Case #Vertical
      \t\x = 0 : \t\y = 0.5 : \t\z = 0 
    Case #tombe
      \t\x = 0 : \t\y = 0 : \t\z = 0 
  EndSelect  
   
  *Ptr=*Sommet
  For i = 1 To 24
    *Ptr\px = (*Ptr\px + \t\x) * \s\x*#Taille
    *Ptr\py = (*Ptr\py + \t\y) * \s\y*#Taille
    *Ptr\pz = (*Ptr\pz + \t\z) * \s\z*#Taille 
    *Ptr + SizeOf(s_Vertex)  
  Next i
     
  SetMeshData(\Mesh, Options      , *Sommet, 24)
  SetMeshData(\Mesh, #PB_Mesh_Face, *Face  , 12)
  FreeEntity(*Player\Entity)
  \Entity=CreateEntity(#PB_Any, MeshID(Mesh(#Player)), MaterialID(Material(#Player)))   
  EntityLocate(\Entity, \p\x-\t\x*\s\x*#Taille, 0, \p\z-\t\z*\s\z*#taille)
  EndWith
  FreeMemory(*Sommet)
  FreeMemory(*Face)
EndProcedure

Procedure MakePont(Entity, Type, Sens, *p.f_Vecteur)
  Define. l Options, i
  Define t.f_Vecteur
  Define *Sommet, *Face, *Ptr.s_Vertex
  
    
  Options = #PB_Mesh_Vertex | #PB_Mesh_Normal | #PB_Mesh_UVCoordinate  
  *Sommet=AllocateMemory(SizeOf(s_Vertex)*24)  
  *Face=AllocateMemory(6*12) 
  
  CopyMemory(?Sommets,*Sommet,SizeOf(s_Vertex)*24)
  CopyMemory(?Triangles,*Face,6*12)

  Select Sens
    Case #Nord
      t\x = 0 : t\y = 0.5 : t\z = 0.5
    Case #Sud
      t\x = 0 : t\y = 0.5 : t\z = -0.5
    Case #Ouest
      t\x = 0.5 : t\y = 0.5 : t\z = 0
    Case #Est 
      t\x = -0.5 : t\y = 0.5 : t\z = 0 
    Case #Vertical
      t\x = 0 : t\y = 0.5 : t\z = 0  
  EndSelect  
   
  *Ptr=*Sommet
  For i = 1 To 24
    *Ptr\px = (*Ptr\px + t\x)
    *Ptr\py = (*Ptr\py + t\y) 
    *Ptr\pz = (*Ptr\pz + t\z) 
    *Ptr + SizeOf(s_Vertex)  
  Next i
     
  SetMeshData(Mesh(Type), Options      , *Sommet, 24)
  SetMeshData(Mesh(Type), #PB_Mesh_Face, *Face  , 12)
  EntityLocate(Entity, *p\x-t\x*#Taille, -2, *p\z-t\z*#Taille)
  FreeMemory(*Sommet)
  FreeMemory(*Face)
EndProcedure

Procedure InitMesh()
  Define Type.l, Options

  For Type = #Vide To #Player

    Select Type
 
      Case #Vide          
      Case #Sol          : CREATE_MESH(#Sol) 
      Case #Sortie       : CREATE_MESH(#Sortie) 
      Case #InterSouple  : CREATE_MESH(#InterSouple)  
      Case #InterDur     : CREATE_MESH(#InterDur) 
      Case #PontGauche   : CREATE_MESH(#PontGauche) 
      Case #PontDroit    : CREATE_MESH(#PontDroit)
      Case #SolOrange    : CREATE_MESH(#SolOrange)  
      Case #InterDouble  : CREATE_MESH(#InterDouble)
      Case #PontHaut     : CREATE_MESH(#PontHaut)
      Case #PontBas      : CREATE_MESH(#PontBas)
      Case #Player       : CREATE_MESH(#Player)    
      
    EndSelect

  Next Type
EndProcedure

Procedure InitMaterial()
  Define Type.l, Tx , Ty

  For Type = #Vide To #Player2

    Select Type
 
      Case #Vide          
      Case #Sol          : CREATE_MATERIAL(#Sol, $FFFFFF) 
      Case #Sortie       : CREATE_MATERIAL(#Sortie, $FFFFFF)
      Case #InterSouple  : CREATE_MATERIAL(#InterSouple, $1199FF)  
      Case #InterDur     : CREATE_MATERIAL(#InterDur, $FF7733) 
      Case #PontGauche   : CREATE_MATERIAL(#PontGauche, $AABB56)
      Case #PontDroit    : CREATE_MATERIAL(#PontDroit, $AABB56)
      Case #SolOrange    : CREATE_MATERIAL(#SolOrange, $00AAFF)  
      Case #InterDouble  : CREATE_MATERIAL(#InterDouble, $A34546)
      Case #PontHaut     : CREATE_MATERIAL(#PontHaut, $FF00AA)
      Case #PontBas      : CREATE_MATERIAL(#PontBas, $FF00AA)
      Case #Player       : CREATE_MATERIAL(#Player, $776666)    
      Case #Player2      : CREATE_MATERIAL(#Player2, $776666)
    EndSelect
      
  Next Type  
EndProcedure
Procedure GestionCamera(*M.Point)
  If ExamineMouse()
    *M\x=MouseX()
    *M\y=MouseY()
    If *M\x<5
      MoveCamera(#Camera,-1,0,0)
    ElseIf *M\x>Screen\Width-5
      MoveCamera(#Camera,1,0,0)
    EndIf
    If *M\y<5
      MoveCamera(#Camera,0,0,1)
    ElseIf *M\y>Screen\Height-5
      MoveCamera(#Camera,0,0,-1)
    EndIf        
  EndIf 
EndProcedure
Procedure.f CurveValue(actuelle.f, Cible.f, P.f) 
   Define.f Delta
   Delta = Cible - actuelle 
   If P > 1000.0 : P = 1000.0 : EndIf 
   ProcedureReturn  (actuelle + ( Delta * P / 1000.0)) 
EndProcedure 



; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 148
; FirstLine = 129
; Folding = --