;Comtois
;PB 4.10 Le 26/08/07

EnableExplicit

XIncludeFile "main.pbi"
InitGame()
XIncludeFile "Menu.pb"
XIncludeFile "3D.pb"
XIncludeFile "Map.pb"
XIncludeFile "Game.pb"


Main()
End

Procedure Main()
  Define.s_Map Map
  Define.s_Player Player
  Define Mouse.point

  Preferences(@Map, @Player)
  
  DisplayMenu(@Map)
  InitMesh()
  InitMaterial()
  LoadMap(@Map, @Player)

  CreateMap(@Map, @Player)
  LoadEvent(@Map)
  LoadSounds()
  
  Repeat
    CoefSelonFPS=60.0/Engine3DFrameRate(#PB_Engine3D_Current) 
    If CoefSelonFPS>3 : CoefSelonFPS=3:EndIf
    GestionClavier(@Map, @Player)
    Animation(@Map, @Player)
    ControleJeu(@Map, @Player)
    AnimationEvent(@Map)
    RenderWorld()
    AFFICHE_INFORMATIONS(Map\Level,Map\Move,Map\MoveTmp)
    FlipBuffers()
    
  Until GetKeyState_(#VK_ESCAPE) & $80;KeyboardPushed(#PB_Key_Escape)
  
EndProcedure

Procedure InitGame()
  If InitEngine3D()=0 
    MessageRequester("Erreur", "Impossible d'initialiser le moteur 3D , vrifier la prsence de Engine3D.dll",0)
    End
  EndIf  
  If InitSprite()=0 Or InitMouse()=0 Or InitSound()=0 Or InitKeyboard()=0 
    MessageRequester("Erreur", "Impossible d'initialiser DirectX",0)
    End
  EndIf
  
  If OpenScreen(Screen\Width,Screen\Height,Screen\Depth,"PureBlock")=0  
    MessageRequester("Erreur", "Impossible d'ouvrir l'cran en " + Str(Screen\Width)+"x"+Str(Screen\Height)+"x32",0)
    End
  EndIf
 
  Add3DArchive("Textures",#PB_3DArchive_FileSystem)
  Add3DArchive("Textures\Skybox.zip", #PB_3DArchive_Zip)
  ;Pour la souris 
  UsePNGImageDecoder()
  If LoadSprite(#Souris,"Sprites\souris.PNG")=0
    MessageErreur("Impossible de charger le fichier Sprite\Souris.PNG")
  EndIf
EndProcedure

Procedure Preferences(*Map.s_Map, *Player.s_Player)
  If OpenPreferences("Preferences.Prefs")
    PreferenceGroup("Global")
    *Player\Vitesse=ReadPreferenceFloat("Speed",4.5)
    If *Player\Vitesse<1.0
      *Player\Vitesse=1.0
    EndIf
    If *Player\Vitesse>50.0
      *Player\Vitesse=50.0
    EndIf   
    ClosePreferences()
  Else
    *Player\Vitesse=5.0  
  EndIf
  *Map\Vitesse=*Player\Vitesse
EndProcedure

Procedure MessageErreur(Texte.s)
  CloseScreen()
  MessageRequester("Erreur", Texte, 0)
  End
EndProcedure    

; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 41
; FirstLine = 14
; Folding = -
; DisableDebugger