XIncludeFile "Map.pbi"

Procedure InitMap(*Map.s_Map, *Player.s_Player)
  Define.l i, j
  
  ClearList(AnimEvent())
  
  For j=1 To #MaxMapZ
    For i = 1 To #MaxMapX
      If IsEntity(DataMap(i,j)\Entity) 
        FreeEntity(DataMap(i,j)\Entity)
        DataMap(i,j)\Entity=0
      EndIf
      DataMap(i,j)\Type=0
      DataMap(i,j)\Etat=0 
      DataMap(i,j)\Entity=0
      DataMap(i,j)\Angle=0
      DataMap(i,j)\c=0
    Next i  
  Next j
  If IsEntity(*Player\Entity) 
    FreeEntity(*Player\Entity)
    *Player\Entity=0
  EndIf     
  If IsEntity(*Player\Entity2) 
    FreeEntity(*Player\Entity2)
    *Player\Entity2=0
  EndIf
EndProcedure

Procedure LoadMap(*Map.s_Map, *Player.s_Player)
  Define.s Fichier
  Define.l i,j
  
  Fichier="Map\Niveau"+Str(*Map\Level)+".map"
  If ReadFile(0, Fichier)
    *Map\SizeX=ReadLong(0)
    *Map\SizeZ=ReadLong(0)
    *Player\Origine\X=ReadLong(0)
    *Player\Origine\Z=ReadLong(0)
    ;Initialise le Joueur
    *Player\Out   =#False
    *Player\Toggle1 = #False
    *Player\Toggle2 = #False
    *Player\Angle=0
    *Player\Bloc1\x=*Player\Origine\X
    *Player\Bloc1\z=*Player\Origine\z
    *Player\Bloc2\x=*Player\Origine\X
    *Player\Bloc2\z=*Player\Origine\z
    *Player\Taille=#Rectangle
    *Player\p\x=*Player\Origine\X*#Taille
    *Player\p\y=0
    *Player\p\z=*Player\Origine\Z*#Taille
    *Player\Type = #Vertical
    *Player\Sens = #Vertical 

    For j=1 To *Map\SizeZ
      For i=1 To *Map\SizeX
        DataMap(i,j)\Type=ReadLong(0)
        DataMap(i,j)\Etat=ReadLong(0)
        ;A utiliser pour des effets quand on perd ou gagne !
        DataMap(i,j)\Random\x = Random(j)-2.5
        DataMap(i,j)\Random\y = (-5-Random(j*i*j))/2.5
        DataMap(i,j)\Random\z = Random(3)-2.5
      Next i
    Next j  
    CloseFile(0)  
  Else
    MessageErreur("Impossible de charger " + Fichier)
  EndIf
EndProcedure

Procedure DisplayMap(*Map.s_Map, *Player.s_Player)
  Define i, j, k
  Define.f Monte,Tombe, Vitesse, x, y, z
  Define.s Texte
  ;Animation pour afficher la map , Todo --> varier les effets
  Monte = 0
  Vitesse = 100*CoefSelonFPS
  Repeat
    Monte + 2*CoefSelonFPS
    Vitesse + 3.0*CoefSelonFPS
    For j=1 To *Map\SizeZ
      For i=1 To *Map\SizeX
        If IsEntity(DataMap(i,j)\Entity) 
          x=CurveValue(EntityX(DataMap(i,j)\Entity),FXMap(i,j)\x,Vitesse)
          y=CurveValue(EntityY(DataMap(i,j)\Entity),FXMap(i,j)\y,Vitesse)
          z=CurveValue(EntityZ(DataMap(i,j)\Entity),FXMap(i,j)\z,Vitesse)
          EntityLocate(DataMap(i,j)\Entity,x,y,z)
        EndIf  
      Next i
    Next j

    RenderWorld()
    AFFICHE_INFORMATIONS(*Map\Level,*Map\Move,*Map\MoveTmp)
    AFFICHE_STAGE()
    FlipBuffers()
  Until Monte >= 130  

  tombe = 132

  Repeat
    tombe - 6*CoefSelonFPS
    MoveEntity(*Player\Entity, 0, -6*CoefSelonFPS, 0)
    RenderWorld()
    AFFICHE_INFORMATIONS(*Map\Level,*Map\Move,*Map\MoveTmp)
    AFFICHE_STAGE()
    FlipBuffers()    
  Until Tombe <= 0
  MoveEntity(*Player\Entity, 0, -Tombe, 0)
EndProcedure

Procedure CreateMap(*Map.s_Map, *Player.s_Player)
  Define.l i, j  
  Define.f_Vecteur Position
  Define.s_Event *Event
  ;Camera
  CameraLocate(#Camera, Camera\Pos\x, Camera\Pos\y, Camera\Pos\z)
  CameraLookAt(#Camera, Camera\LookAt\x, Camera\LookAt\y, Camera\LookAt\z)

  ;-Entity
  *Player\Mesh= Mesh(#Player)
  *Player\Entity=CreateEntity(#PB_Any, MeshID(Mesh(#Player)), MaterialID(Material(#Player)))
  MakeMesh(*Player)
  MoveEntity(*Player\Entity,0,132,0) 
   
  ;Prpare le second cube ds le dpart du jeu et on le cache
  *Player\Entity2=CreateEntity(#PB_Any, MeshID(Mesh(#Sol)), MaterialID(Material(#Player2)))
  ScaleEntity(*Player\Entity2,#Taille,#Taille,#Taille)
  HideEntity(*Player\Entity2,1)

  ;Contruction de la map
  For j=1 To *Map\SizeZ
    For i=1 To *Map\SizeX 
      If DataMap(i,j)\Type 
        Select DataMap(i,j)\Type
          Case #Sol
            DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#Sol)), MaterialID(Material(#Sol)))
            EntityLocate(DataMap(i,j)\Entity, i*#Taille, -1, j*#Taille)
          Case #Sortie
            DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#Sortie)), MaterialID(Material(#Sortie)))
            EntityLocate(DataMap(i,j)\Entity, i*#Taille, -3, j*#Taille)
          Case #InterSouple
            DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#InterSouple)), MaterialID(Material(#InterSouple)))
            EntityLocate(DataMap(i,j)\Entity, i*#Taille, -1, j*#Taille)
          Case #InterDur
            DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#InterDur)), MaterialID(Material(#InterDur)))
            EntityLocate(DataMap(i,j)\Entity, i*#Taille, -1, j*#Taille)
          Case #PontGauche
            DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#PontGauche)), MaterialID(Material(#PontGauche)))
            Position\x = i*#Taille : Position\y = 0 : Position\z = j*#Taille
            MakePont(DataMap(i,j)\Entity,#PontGauche,#Ouest, @Position)
            DataMap(i,j)\Angle=-90
            RotateEntity(DataMap(i,j)\Entity,0,0,DataMap(i,j)\Angle)
            ;Ajoute un vnement pour fermer le pont
            If DataMap(i,j)\Etat=#Close ; Demande de fermeture ?
              DataMap(i,j)\Etat=#Open   ; Mise  jour de l'tat rel 
              AddElement(AnimEvent())
              AnimEvent()\NbEvent=1
              AnimEvent()\Event=AllocateMemory(SizeOf(s_event)) 
              AnimEvent()\Event\Type=#Close
              AnimEvent()\Event\Bloc\x=i
              AnimEvent()\Event\Bloc\z=j
              AnimEvent()\Event\Next=#Null  
            EndIf  
            
          Case #PontDroit
            DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#PontDroit)), MaterialID(Material(#PontDroit)))
            Position\x = i*#Taille : Position\y = 0 : Position\z = j*#Taille
            MakePont(DataMap(i,j)\Entity,#PontDroit,#Est, @Position)
            DataMap(i,j)\Angle=90
            RotateEntity(DataMap(i,j)\Entity,0,0,DataMap(i,j)\Angle)
            ;Ajoute un vnement pour fermer le pont
            If DataMap(i,j)\Etat=#Close ; Demande de fermeture ?
              DataMap(i,j)\Etat=#Open   ; Mise  jour de l'tat rel
              AddElement(AnimEvent())
              AnimEvent()\NbEvent=1
              AnimEvent()\Event=AllocateMemory(SizeOf(s_event)) 
              AnimEvent()\Event\Type=#Close
              AnimEvent()\Event\Bloc\x=i
              AnimEvent()\Event\Bloc\z=j
              AnimEvent()\Event\Next=#Null    
            EndIf

          Case #PontHaut
            DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#PontHaut)), MaterialID(Material(#PontHaut)))
            Position\x = i*#Taille : Position\y = 0 : Position\z = j*#Taille
            MakePont(DataMap(i,j)\Entity,#PontHaut,#Nord, @Position)
            DataMap(i,j)\Angle=90
            RotateEntity(DataMap(i,j)\Entity,0,DataMap(i,j)\Angle,0)
            ;Ajoute un vnement pour fermer le pont
            If DataMap(i,j)\Etat=#Close ; Demande de fermeture ?
              DataMap(i,j)\Etat=#Open   ; Mise  jour de l'tat rel 
              AddElement(AnimEvent())
              AnimEvent()\NbEvent=1
              AnimEvent()\Event=AllocateMemory(SizeOf(s_event)) 
              AnimEvent()\Event\Type=#Close
              AnimEvent()\Event\Bloc\x=i
              AnimEvent()\Event\Bloc\z=j
              AnimEvent()\Event\Next=#Null  
            EndIf  
            
          Case #PontBas
            DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#PontBas)), MaterialID(Material(#PontBas)))
            Position\x = i*#Taille : Position\y = 0 : Position\z = j*#Taille
            MakePont(DataMap(i,j)\Entity,#PontBas,#Sud, @Position)
            DataMap(i,j)\Angle=-90
            RotateEntity(DataMap(i,j)\Entity,0,DataMap(i,j)\Angle,0)
            ;Ajoute un vnement pour fermer le pont
            If DataMap(i,j)\Etat=#Close ; Demande de fermeture ?
              DataMap(i,j)\Etat=#Open   ; Mise  jour de l'tat rel
              AddElement(AnimEvent())
              AnimEvent()\NbEvent=1
              AnimEvent()\Event=AllocateMemory(SizeOf(s_event)) 
              AnimEvent()\Event\Type=#Close
              AnimEvent()\Event\Bloc\x=i
              AnimEvent()\Event\Bloc\z=j
              AnimEvent()\Event\Next=#Null    
            EndIf
                        
          Case #SolOrange
            DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#SolOrange)), MaterialID(Material(#SolOrange)))
            EntityLocate(DataMap(i,j)\Entity, i*#Taille, -1, j*#Taille)
          Case #InterDouble
            DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#InterDouble)), MaterialID(Material(#InterDouble)))
            EntityLocate(DataMap(i,j)\Entity, i*#Taille, -1, j*#Taille)
        EndSelect
        
        ScaleEntity(DataMap(i,j)\Entity, #Taille, 2, #Taille) 
       
        ;Mmorise la position de l'entity avant de l'expdier dans l'espace 
        FXMap(i,j)\x=EntityX(DataMap(i,j)\Entity)
        FXMap(i,j)\y=EntityY(DataMap(i,j)\Entity)
        FXMap(i,j)\z=EntityZ(DataMap(i,j)\Entity)
        MoveEntity(DataMap(i,j)\Entity,300-Random(600),300-Random(600),300-Random(600))
      EndIf
    Next i
  Next j  
  DisplayMap(*Map, *Player)
EndProcedure

;**********************
;*   Pour l'diteur   *
;**********************
Procedure OuvreMap(*Map.s_Map)
  Define.s Repertoire, Titre, FichierParDefaut,Filtre,Fichier 
  Define.l  FiltrePosition
  Repertoire = Space(256)
  GetCurrentDirectory_(256,@Repertoire)
  
  Titre = "Ouvre une map"
  FichierParDefaut = Repertoire+"\Map\*.map" 
  Filtre = "Fichiers PureBlock |*.map" 
  FiltrePosition = 0
  Fichier = OpenFileRequester(Titre, FichierParDefaut, Filtre, FiltrePosition) 
  Fichier=GetFilePart(Fichier)  
  Fichier=RemoveString(Fichier,".map",1)
  Fichier=RemoveString(Fichier,"Niveau",1)
  *Map\Level=Val(Fichier)
EndProcedure
Procedure EnregistreMap(*Map.s_Map,*Player.s_Player)
  Define i,j
  Define.s Repertoire, Titre, FichierParDefaut,Filtre,Fichier,Level 
  Define.l  FiltrePosition
  Repertoire = Space(256)
  GetCurrentDirectory_(256,@Repertoire)
  
  Titre = "Enregistre une map"
  FichierParDefaut = Repertoire+"\Map\*.map" 
  Filtre = "Fichiers PureBlock |*.map" 
  FiltrePosition = 0
  Fichier = SaveFileRequester(Titre, FichierParDefaut, Filtre, FiltrePosition) 
  If LCase(GetExtensionPart(Fichier))<>"map"
    Fichier + ".map"
  EndIf  
  Level=GetFilePart(Fichier)  
  Level=RemoveString(Level,".map",1)
  Level=RemoveString(Level,"Niveau",1)
  *Map\Level=Val(Level)
  
  ;Cherche les SizeX et SizeZ
  For j=1 To #MaxMapZ
    For i=1 To #MaxMapX
      If DataMap(i,j)\Type
        If *Map\SizeX<i
          *Map\SizeX= i
        EndIf
        If *Map\SizeZ<j
          *Map\SizeZ= j
        EndIf          
      EndIf
    Next i
  Next j  
  If CreateFile(0,Fichier)
    WriteLong(0,*Map\SizeX)
    WriteLong(0,*Map\SizeZ)
    WriteLong(0,*Player\Origine\x)
    WriteLong(0,*Player\Origine\z)  
    For j=1 To  *Map\SizeZ
      For i=1 To *Map\SizeX
        WriteLong(0, DataMap(i,j)\Type)
        WriteLong(0, DataMap(i,j)\Etat)
      Next i
    Next j    
    CloseFile(0)
  EndIf  
EndProcedure   
Procedure InitPlayer(*Player.s_Player)
  If IsEntity(*Player\Entity)=0
    If *Player\Origine\X = 0 Or *Player\Origine\Z = 0 
      *Player\Origine\X=1
      *Player\Origine\Z=1
    EndIf
    ;Initialise le Joueur
    *Player\Out   =#False
    *Player\Toggle1 = #False
    *Player\Toggle2 = #False
    *Player\Angle=0
    *Player\Bloc1\x=*Player\Origine\X
    *Player\Bloc1\z=*Player\Origine\z
    *Player\Bloc2\x=*Player\Origine\X
    *Player\Bloc2\z=*Player\Origine\z
    *Player\Taille=#Rectangle
    *Player\p\x=*Player\Origine\X*#Taille
    *Player\p\y=0
    *Player\p\z=*Player\Origine\Z*#Taille
    *Player\Type = #Vertical
    *Player\Sens = #Vertical 
    *Player\Mesh= Mesh(#Player)
    *Player\Entity=CreateEntity(#PB_Any, MeshID(Mesh(#Player)), MaterialID(Material(#Player)))
    MakeMesh(*Player)
  EndIf
EndProcedure
Procedure InitBloc(*Map.s_map)
  Define.l i,j
  i=*Map\Bloc\x
  j=*Map\Bloc\z
  If IsEntity(DataMap(i,j)\Entity)
    FreeEntity(DataMap(i,j)\Entity)
    DataMap(i,j)\Entity=0
  EndIf
    
  DataMap(i,j)\Type=*Map\Type 
  DataMap(i,j)\Etat=*Map\Etat
EndProcedure

Procedure AddBloc(*Map.s_Map, *Player.s_Player,i,j)
  Define.f_Vecteur Position

  Select DataMap(i,j)\Type
    Case #Sol
      DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#Sol)), MaterialID(Material(#Sol)))
      EntityLocate(DataMap(i,j)\Entity, i*#Taille, -1, j*#Taille)
    Case #Sortie
      DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#Sortie)), MaterialID(Material(#Sortie)))
      EntityLocate(DataMap(i,j)\Entity, i*#Taille, -3, j*#Taille)
    Case #InterSouple
      DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#InterSouple)), MaterialID(Material(#InterSouple)))
      EntityLocate(DataMap(i,j)\Entity, i*#Taille, -1, j*#Taille)
    Case #InterDur
      DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#InterDur)), MaterialID(Material(#InterDur)))
      EntityLocate(DataMap(i,j)\Entity, i*#Taille, -1, j*#Taille)
    Case #PontGauche
      DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#PontGauche)), MaterialID(Material(#PontGauche)))
      Position\x = i*#Taille : Position\y = 0 : Position\z = j*#Taille
      MakePont(DataMap(i,j)\Entity,#PontGauche,#Ouest, @Position)
    Case #PontDroit
      DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#PontDroit)), MaterialID(Material(#PontDroit)))
      Position\x = i*#Taille : Position\y = 0 : Position\z = j*#Taille
      MakePont(DataMap(i,j)\Entity,#PontDroit,#Est, @Position)
    Case #PontHaut
      DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#PontHaut)), MaterialID(Material(#PontHaut)))
      Position\x = i*#Taille : Position\y = 0 : Position\z = j*#Taille
      MakePont(DataMap(i,j)\Entity,#PontHaut,#Nord, @Position)
    Case #PontBas
      DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#PontBas)), MaterialID(Material(#PontBas)))
      Position\x = i*#Taille : Position\y = 0 : Position\z = j*#Taille
      MakePont(DataMap(i,j)\Entity,#PontBas,#Sud, @Position)
    Case #SolOrange
      DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#SolOrange)), MaterialID(Material(#SolOrange)))
      EntityLocate(DataMap(i,j)\Entity, i*#Taille, -1, j*#Taille)
    Case #InterDouble
      DataMap(i,j)\Entity= CreateEntity(#PB_Any, MeshID(Mesh(#InterDouble)), MaterialID(Material(#InterDouble)))
      EntityLocate(DataMap(i,j)\Entity, i*#Taille, -1, j*#Taille)
  EndSelect
  
  If IsEntity(DataMap(i,j)\Entity)
    ScaleEntity(DataMap(i,j)\Entity, #Taille, 2, #Taille) 
  EndIf 
EndProcedure
; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 81
; FirstLine = 72
; Folding = --